/*
 * _globals.h
 *
 *  Created on: 7. mars 2021
 *      Author: teig
 */


#ifndef GLOBALS_H_
#define GLOBALS_H_

    // BOOLEAN #include <stdbool.h> if C99
    // See http://www.teigfam.net/oyvind/home/technology/165-xc-code-examples/#bool
    typedef enum {false,true} bool; // 0,1 This typedef matches any integer-type type like long, int, unsigned, char, bool

    typedef signed int time32_t; // signed int (=signed) or unsigned int (=unsigned) both ok, as long as they are monotoneously increasing
                                 // XC/XMOS 100 MHz increment every 10 ns for max 2exp32 = 4294967296,
                                 // ie. divide by 100 mill = 42.9.. seconds

    #define min(a,b) (((a)<(b))?(a):(b))
    #define max(a,b) (((a)>(b))?(a):(b))
    #define abs(a)   (((a)<0)?(-(a)):(a))

    #define IS_MYTARGET_VOID               0
    #define IS_MYTARGET_STARTKIT           1 // Not used
    #define IS_MYTARGET_XCORE_200_EXPLORER 2 // USED
    #define IS_MYTARGET_XCORE_XA_MODULE    3 // Not used

    #ifndef MYTARGET
        #error // Define in XCC_FLAGS like -DMYTARGET=XCORE-200-EXPLORER
    #elif (MYTARGET==XCORE-200-EXPLORER)
        #define IS_MYTARGET IS_MYTARGET_XCORE_200_EXPLORER
    #else
        #define IS_MYTARGET IS_MYTARGET_VOID
        #error NO TARGET DEFINED
    #endif

#endif /* GLOBALS_H_ */
